#install.packages("glmnet")
library(glmnet)

#######################
#######################

m=100
Coef_T=matrix(0,10,m)
Coef_F=matrix(0,10,m)

for(j in 1:m){
  
  #Generate individual means for 4 bottom variables x1,x2,x3,and x4
  N=1000
  #Generate individual means for 4 bottom variables x1,x2,x3,and x4
  lambda<-matrix(0,N,6)
  lambda[,1]<-rgamma(N, shape=5, rate = 2)
  lambda[,2]<-rgamma(N, shape=5, rate = 2)
  lambda[,3]<-rgamma(N, shape=5, rate = 3)
  lambda[,4]<-rgamma(N, shape=8, rate = 2)
  lambda[,5]<-rgamma(N, shape=9, rate = 4)
  lambda[,6]<-rgamma(N, shape=5, rate = 2)
  
  
  LAMBDA=lambda[,1:4]
  LAMBDA=cbind(1,LAMBDA)
  
  
  
  
  
  #Generate x1,x2,x3,and 4 variable (together called X) by assuming a poisson distribution with the generated means
  X=matrix(0,N,4)
  for(i in 1:4)X[,i]=rpois(N,lambda[,i])
  X=cbind(1,X)
  
  #Assume a sparse structure that only x4 variable is associated with disease (non-zero coefficient)
  Beta=c(-10,0,0,0,3)
  
  #Generate the binary response variable Y for each individual in terms of the logit link
  t=exp(LAMBDA%*%Beta)
  p=t/(1+t)
  Y=rbinom(N, 1, p)
  
  
  #Adding the tree structure 
  
  XX=data.frame(X[,-1])
  XX$X5=XX$X1+XX$X2
  XX$X6=XX$X3+XX$X4
  
  #Adding some noise variables X7 and X8 (at level 2 means they don't have children)
  
  XX$X7=rpois(N,lambda[,5])
  XX$X8=rpois(N,lambda[,6])
  
  
  dat=XX
  XX$X9=XX$X1+XX$X2+XX$X3+XX$X4+XX$X7+XX$X8
  
  #row scale the X matrix
  dat=as.matrix(XX)
#apply(dat,2,var)-apply(dat,2,mean)

  for(i in 1:dim(dat)[2])dat[,i]=dat[,i]/sqrt(var(dat[,i])-mean(dat[,i]))

  for(i in 1:N)dat[i,]=dat[i,]/sum(dat[i,c(1:4,7,8)])

  
  
  ind=sample(1:dim(dat)[1],N)
  dat.tr=dat[ind,]
  #dat.te=dat2[-ind,]
  
  cv=cv.glmnet(dat.tr,Y[ind],family="binomial",standardize=T)

  model=glmnet(dat.tr,Y[ind],family="binomial",standardize=T,lambda=cv$lambda.1se)

  Coef_T[,j]=as.vector(coef(model))

  cv2=cv.glmnet(dat.tr,Y[ind],family="binomial",standardize=F)

  model2=glmnet(dat.tr,Y[ind],family="binomial",standardize=F,lambda=cv2$lambda.1se)

  Coef_F[,j]=as.vector(coef(model2))
  
  
  
}





Convert<-function(m){
  M=matrix(0,dim(m)[1],dim(m)[2])
  for(i in 1:dim(m)[1]){for(j in 1:dim(m)[2])if(m[i,j]!=0)M[i,j]=1  }
  return(M)
}

M_F=Convert(Coef_F)
M_T=Convert(Coef_T)
apply(M_F[,1:100],1,sum)
apply(M_T[,1:100],1,sum)

 
sum(apply(M_F[c(4,7),],2,sum)==2)
sum(apply(M_T[c(4,7),],2,sum)==2)
sum(apply(M_F[c(5,7),],2,sum)==2)
sum(apply(M_T[c(5,7),],2,sum)==2)
